<template>
    <v-card>
        <v-card-text class="mb-0 pb-0">
            <v-layout row wrap>
                <v-flex xs12>
                    <div class="editable mt-4" style="white-space: pre-line;">
                        <div v-if="!edit"
                             @click="startEdit()">
                            <div v-if="!!root.content">{{root.content}}</div>
                            <div v-if="!root.content"> 
                                <span style="font-style: italic; color: #999">{{$i18n.t("note.actions.edit.description")}}</span>
                            </div>
                        </div>
                        <div v-if="edit" >
                            <v-textarea
                                @blur="endEdit()" 
                                @keydown.ctrl.enter="endEdit()" 
                                @keydown.esc="cancelEdit()" 
                                autofocus
                                browser-autocomplete='off' 
                                rows="1" 
                                auto-grow 
                                v-model="root.content"></v-textarea>
                       </div>
                    </div>
                </v-flex>
                <v-flex xs12 class="text-xs-right mt-4 update-time">
                   {{$i18n.t("common.updated.fm")}} {{formatDate(root.updated)}}
                </v-flex>
            </v-layout>
        </v-card-text>
        <v-divider light></v-divider>
        <v-card-actions right>
            <v-spacer/>
            <v-btn flat small icon @click="$emit('delete')"><v-icon small>delete</v-icon></v-btn>
        </v-card-actions>
    </v-card>
</template>


<script>
import moment from 'moment'
export default {
    name: 'NoteCard',
    props: ['note', 'application'],
    data() {
        return {
            edit: false,
            originalContent: null,
            root: this.note
        }
    },
    methods: {
        startEdit() {
            this.originalContent = this.root.content
            this.edit = true
        },
        cancelEdit() {
            this.edit = false
            this.root = Object.assign({}, this.root, {content: this.originalContent})
        },
        async endEdit() {
            this.edit = false
            const saved = await this.$api.updateNote(this.application.id, this.root);
            this.root = Object.assign({}, this.root, saved)
            delete this.originalContent
        },
        formatDate(d, format) {
            return !format ? moment(d).fromNow() : moment(d).format(format)
        }
    }
}
</script>